hpp-constraints: hpp::constraints::LockedJoint Class Reference

hpp-constraints 9.0.2 Definition of basic geometric constraints for motion planning

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
hpp::constraints::LockedJoint Class Reference
Constraints

`#include <hpp/constraints/locked-joint.hh>`

Inheritance diagram for hpp::constraints::LockedJoint:
[legend]
Collaboration diagram for hpp::constraints::LockedJoint:
[legend]

## Public Member Functions
virtual ImplicitPtr_t | copy () const
| Copy object and return shared pointer to copy.
size_type | rankInConfiguration () const
| Get index of locked degree of freedom in robot configuration vector.
size_type | rankInVelocity () const
| Get index of locked degree of freedom in robot velocity vector.
size_type | configSize () const
| Get the configuration size of the joint.
size_type | numberDof () const
| Get number of degrees of freedom of the joint.
const LiegroupSpacePtr_t & | configSpace () const
| Get configuration space of locked joint.
vectorIn_t | value () const
| Get the value of the locked joint.
void | value (vectorIn_t value)
| Set the value of the locked joint.
const JointPtr_t & | joint ()
| Return shared pointer to joint.
const std::string & | jointName () const
| Return the joint name.
std::ostream & | print (std::ostream &os) const
| Print object in a stream.
virtual std::pair< JointConstPtr_t, JointConstPtr_t > | doesConstrainRelPoseBetween (DeviceConstPtr_t robot) const
Public Member Functions inherited from hpp::constraints::Explicit
DifferentiableFunctionPtr_t | explicitFunction () const
const segments_t & | outputConf () const
| Get output configuration variables.
const segments_t & | outputVelocity () const
| Get output degrees of freedom.
const segments_t & | inputConf () const
| Get input configuration variables.
const segments_t & | inputVelocity () const
| Get input degrees of freedom.
virtual void | outputValue (LiegroupElementRef result, vectorIn_t qin, LiegroupElementConstRef rhs) const
virtual void | jacobianOutputValue (vectorIn_t qin, LiegroupElementConstRef g_value, LiegroupElementConstRef rhs, matrixOut_t jacobian) const
Public Member Functions inherited from hpp::constraints::Implicit
bool | operator== (const Implicit &other) const
| Operator equality.
Implicit & | operator= (const Implicit &other)
| Operator assignation.
virtual | ~Implicit ()
const ComparisonTypes_t & | comparisonType () const
| Return the ComparisonType.
void | comparisonType (const ComparisonTypes_t &comp)
| Set the comparison type.
const segments_t & | activeRows () const
bool | checkAllRowsActive () const
| Check if all rows are active (no inactive rows)
const Eigen::RowBlockIndices & | equalityIndices () const
| Get indices of constraint coordinates that are equality.
void | setInactiveRowsToZero (vectorOut_t error) const
DifferentiableFunction & | function () const
| Return a reference to function .
const DifferentiableFunctionPtr_t & | functionPtr () const
| Return a reference to function .
void | rightHandSideFromConfig (ConfigurationIn_t config, LiegroupElementRef rhs)
bool | checkRightHandSide (LiegroupElementConstRef rhs) const
size_type | parameterSize () const
size_type | rightHandSideSize () const
void | rightHandSideFunction (const DifferentiableFunctionPtr_t &rhsF)
const DifferentiableFunctionPtr_t & | rightHandSideFunction () const
vectorIn_t | rightHandSideAt (const value_type &s)

## Static Public Member Functions
static LockedJointPtr_t | create (const JointPtr_t &joint, const LiegroupElement &value)
static LockedJointPtr_t | create (const JointPtr_t &joint, const size_type index, vectorIn_t value)
static LockedJointPtr_t | create (const DevicePtr_t &dev, const size_type index, vectorIn_t value)
static LockedJointPtr_t | createCopy (LockedJointConstPtr_t other)
Static Public Member Functions inherited from hpp::constraints::Explicit
static ExplicitPtr_t | create (const LiegroupSpacePtr_t &configSpace, const DifferentiableFunctionPtr_t &function, const segments_t &inputConf, const segments_t &outputConf, const segments_t &inputVelocity, const segments_t &outputVelocity, const ComparisonTypes_t &comp=ComparisonTypes_t(), std::vector< bool > mask=std::vector< bool >())
static ExplicitPtr_t | createCopy (const ExplicitPtr_t &other)
| Create a copy and return shared pointer.
Static Public Member Functions inherited from hpp::constraints::Implicit
static ImplicitPtr_t | create (const DifferentiableFunctionPtr_t &func, ComparisonTypes_t comp, std::vector< bool > mask=std::vector< bool >())
static ImplicitPtr_t | createCopy (const ImplicitPtr_t &other)
| Create a copy and return shared pointer.

## Protected Member Functions
| LockedJoint (const JointPtr_t &joint, const LiegroupElement &value)
| LockedJoint (const JointPtr_t &joint, const size_type index, vectorIn_t value)
| LockedJoint (const DevicePtr_t &robot, const size_type index, vectorIn_t value)
| LockedJoint (const LockedJoint &other)
| Copy constructor.
virtual bool | isEqual (const Implicit &other, bool swapAndTest) const
void | init (const LockedJointPtr_t &self)
Protected Member Functions inherited from hpp::constraints::Explicit
| Explicit (const LiegroupSpacePtr_t &configSpace, const DifferentiableFunctionPtr_t &function, const segments_t &inputConf, const segments_t &outputConf, const segments_t &inputVelocity, const segments_t &outputVelocity, const ComparisonTypes_t &comp, std::vector< bool > mask)
| Explicit (const DifferentiableFunctionPtr_t &implicitFunction, const DifferentiableFunctionPtr_t &function, const segments_t &inputConf, const segments_t &outputConf, const segments_t &inputVelocity, const segments_t &outputVelocity, const ComparisonTypes_t &comp, std::vector< bool > mask)
  | (const LiegroupSpacePtr_t&, constDifferentiableFunctionPtr_t&, const segments_t& inputConf, constsegments_t& outputConf, const segments_t& inputVelocity, constsegments_t&, const ComparisonTypes_t&); Parameters
  implicitFunction |
| Explicit (const Explicit &other)
| Copy constructor.
void | init (const ExplicitWkPtr_t &weak)
| Explicit ()
Protected Member Functions inherited from hpp::constraints::Implicit
| Implicit (const DifferentiableFunctionPtr_t &function, ComparisonTypes_t comp, std::vector< bool > mask)
| Implicit (const Implicit &other)
| Copy constructor.
void | init (const ImplicitWkPtr_t &weak)
| Implicit ()

## Additional Inherited Members
Protected Attributes inherited from hpp::constraints::Explicit
DifferentiableFunctionPtr_t | inputToOutput_
segments_t | inputConf_
segments_t | outputConf_
segments_t | inputVelocity_
segments_t | outputVelocity_

## Detailed Description

Implementation of constraint specific to a locked joint.

The implicit formulation as defined in class Implicit is given by

where is an element of the configuration space of the locked joint passed to method create.

Note that takes values in where is the dimension of the joint tangent space.

The explicit formulation is given by

where coordinates of corresponding to comparison types different from Equality are set to 0.

As such, the relation between the explicit formulation and the implicit formulation is the default one.

## Constructor & Destructor Documentation

## ◆ LockedJoint() [1/4]

hpp::constraints::LockedJoint::LockedJoint | ( | const JointPtr_t & | joint,
|  | const LiegroupElement & | value )
| protected

Constructor

Parameters

  joint | joint that is locked,
  value | of the constant joint config,

## ◆ LockedJoint() [2/4]

hpp::constraints::LockedJoint::LockedJoint | ( | const JointPtr_t & | joint,
|  | const size_type | index,
|  | vectorIn_t | value )
| protected

Constructor of partial locked joint

Parameters

  joint | joint that is locked,
  index | first locked degree of freedom in the joint,
  value | of the constant joint partial config, size of value determines the number of degrees of freedom locked.

Note
  valid only for translation joints.

## ◆ LockedJoint() [3/4]

hpp::constraints::LockedJoint::LockedJoint | ( | const DevicePtr_t & | robot,
|  | const size_type | index,
|  | vectorIn_t | value )
| protected

Constructor of locked degrees of freedom of extra config space

Parameters

  robot | robot
  index | index of the first locked extra degree of freedom,
  value | of the locked degrees of freedom, size of value determines the number of degrees of freedom locked.

## ◆ LockedJoint() [4/4]

hpp::constraints::LockedJoint::LockedJoint | ( | const LockedJoint & | other | ) |
| protected

Copy constructor.

## Member Function Documentation

## ◆ configSize()

size_type hpp::constraints::LockedJoint::configSize | ( |  | ) | const

Get the configuration size of the joint.

## ◆ configSpace()

const LiegroupSpacePtr_t & hpp::constraints::LockedJoint::configSpace | ( |  | ) | const

Get configuration space of locked joint.

## ◆ copy()

virtual ImplicitPtr_t hpp::constraints::LockedJoint::copy | ( |  | ) | const
| virtual

Copy object and return shared pointer to copy.

Reimplemented from hpp::constraints::Explicit.

## ◆ create() [1/3]

static LockedJointPtr_t hpp::constraints::LockedJoint::create | ( | const DevicePtr_t & | dev,
|  | const size_type | index,
|  | vectorIn_t | value )
| static

Create locked degrees of freedom of extra config space

Parameters

  dev | robot
  index | index of the first locked extra degree of freedom,
  value | of the locked degrees of freedom, size of value determines the number of degrees of freedom locked.

## ◆ create() [2/3]

static LockedJointPtr_t hpp::constraints::LockedJoint::create | ( | const JointPtr_t & | joint,
|  | const LiegroupElement & | value )
| static

Create locked joint and return shared pointer

Parameters

  joint | joint that is locked,
  value | of the constant joint config,

## ◆ create() [3/3]

static LockedJointPtr_t hpp::constraints::LockedJoint::create | ( | const JointPtr_t & | joint,
|  | const size_type | index,
|  | vectorIn_t | value )
| static

Create partial locked joint (only some degrees of freedom)

Parameters

  joint | joint that is locked,
  index | first locked degree of freedom in the joint,
  value | of the constant joint partial config, size of value determines the number of degrees of freedom locked.

Note
  valid only for translation joints.

## ◆ createCopy()

static LockedJointPtr_t hpp::constraints::LockedJoint::createCopy | ( | LockedJointConstPtr_t | other | ) |
| static

Return shared pointer to copy

Parameters

  other | instance to copy.

## ◆ doesConstrainRelPoseBetween()

virtual std::pair< JointConstPtr_t, JointConstPtr_t > hpp::constraints::LockedJoint::doesConstrainRelPoseBetween | ( | DeviceConstPtr_t | robot | ) | const
| virtual

Get pair of joints whose relative pose is fully constrained

Parameters

  robot | the device that this constraint is applied to

Returns
  pair of pointers to the parent joint and the locked joint, arranged in order of increasing joint index

Note
  absolute pose is considered relative pose with respect to "universe". "universe" is returned as a nullpointer as the first element of the pair, if applicable.

Reimplemented from hpp::constraints::Implicit.

## ◆ init()

void hpp::constraints::LockedJoint::init | ( | const LockedJointPtr_t & | self | ) |
| protected

## ◆ isEqual()

virtual bool hpp::constraints::LockedJoint::isEqual | ( | const Implicit & | other,
|  | bool | swapAndTest ) const
| protected virtual

Test equality with other instance

Parameters

  other | object to copy
  swapAndTest | whether we should also check other == this

Reimplemented from hpp::constraints::Explicit.

## ◆ joint()

const JointPtr_t & hpp::constraints::LockedJoint::joint | ( |  | ) |
| inline

Return shared pointer to joint.

## ◆ jointName()

const std::string & hpp::constraints::LockedJoint::jointName | ( |  | ) | const
| inline

Return the joint name.

## ◆ numberDof()

size_type hpp::constraints::LockedJoint::numberDof | ( |  | ) | const

Get number of degrees of freedom of the joint.

## ◆ print()

std::ostream & hpp::constraints::LockedJoint::print | ( | std::ostream & | os | ) | const

Print object in a stream.

## ◆ rankInConfiguration()

size_type hpp::constraints::LockedJoint::rankInConfiguration | ( |  | ) | const

Get index of locked degree of freedom in robot configuration vector.

## ◆ rankInVelocity()

size_type hpp::constraints::LockedJoint::rankInVelocity | ( |  | ) | const

Get index of locked degree of freedom in robot velocity vector.

## ◆ value() [1/2]

vectorIn_t hpp::constraints::LockedJoint::value | ( |  | ) | const

Get the value of the locked joint.

## ◆ value() [2/2]

void hpp::constraints::LockedJoint::value | ( | vectorIn_t | value | ) |

Set the value of the locked joint.

The documentation for this class was generated from the following file:

- include/hpp/constraints/locked-joint.hh